Index: /XIOS3/branches/xios-3.0-beta/arch/arch-GCC_MACOSX.fcm
===================================================================
--- /XIOS3/branches/xios-3.0-beta/arch/arch-GCC_MACOSX.fcm	(revision 2468)
+++ /XIOS3/branches/xios-3.0-beta/arch/arch-GCC_MACOSX.fcm	(revision 2469)
@@ -7,10 +7,10 @@
 %LINKER         mpif90
 
-%BASE_CFLAGS    -w
+%BASE_CFLAGS    -w -std=gnu++11
 %PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
 %DEV_CFLAGS     -g
 %DEBUG_CFLAGS   -g -O2
 
-%BASE_FFLAGS    -D__NONE__
+%BASE_FFLAGS    -D__NONE__ -ffree-line-length-none
 %PROD_FFLAGS    -O3
 %DEV_FFLAGS     -g -O2
@@ -20,6 +20,6 @@
 %BASE_LD        -lstdc++
 
-%CPP            /opt/local/bin/cpp-mp-4.5
-%FPP            /opt/local/bin/cpp-mp-4.5 -P
-%MAKE           gmake
+%CPP            cpp
+%FPP            cpp -P
+%MAKE           make
 
Index: /XIOS3/branches/xios-3.0-beta/src/attribute_map.cpp
===================================================================
--- /XIOS3/branches/xios-3.0-beta/src/attribute_map.cpp	(revision 2468)
+++ /XIOS3/branches/xios-3.0-beta/src/attribute_map.cpp	(revision 2469)
@@ -402,5 +402,5 @@
            {
              oss << ", " << it->second->getName() << "_";
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -452,5 +452,5 @@
            {
              oss << ", " << it->second->getName() << "_";
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -502,5 +502,5 @@
            {
              oss << ", " << it->second->getName() << "_";
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -552,5 +552,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -587,5 +587,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -614,5 +614,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -649,5 +649,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -676,5 +676,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -711,5 +711,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -738,5 +738,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -776,5 +776,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -803,5 +803,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -841,5 +841,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -868,5 +868,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
@@ -906,5 +906,5 @@
            {
              oss << ", " << it->second->getName();
-             if (oss.tellp() - startPos > 90)
+             if ((long)oss.tellp() - startPos > 90)
              {
                oss << "  &" << iendl;
Index: /XIOS3/branches/xios-3.0-beta/src/log_type.hpp
===================================================================
--- /XIOS3/branches/xios-3.0-beta/src/log_type.hpp	(revision 2468)
+++ /XIOS3/branches/xios-3.0-beta/src/log_type.hpp	(revision 2469)
@@ -6,4 +6,5 @@
 #include <cstdint>
 #include <unordered_map>
+#include <map>
 
 //#include "cxios.hpp"