Index: XIOS3/branches/xios-3.0-beta/generic_testcase/iodef.xml
===================================================================
--- XIOS3/branches/xios-3.0-beta/generic_testcase/iodef.xml	(revision 2487)
+++ XIOS3/branches/xios-3.0-beta/generic_testcase/iodef.xml	(revision 2495)
@@ -89,5 +89,4 @@
 	<variable id="min_buffer_size" type="int">10000</variable>
 	<variable id="optimal_buffer_size" type="string">performance</variable>
-	<variable id="buffer_factor_size" type="double">0.8</variable> 
       </variable_group>
 
Index: XIOS3/branches/xios-3.0-beta/src/node/variable.cpp
===================================================================
--- XIOS3/branches/xios-3.0-beta/src/node/variable.cpp	(revision 2487)
+++ XIOS3/branches/xios-3.0-beta/src/node/variable.cpp	(revision 2495)
@@ -38,4 +38,5 @@
       SuperClass::parse(node);
       StdString id = (this->hasId()) ? this->getId() : StdString("undefined");
+      if (CContext::getCurrent()->getId()=="xios") checkInDictionary(id);
       if (!node.getContent(this->content))
       {
@@ -60,4 +61,45 @@
       }
       content = boost::trim_copy(content) ;
+   }
+
+   void CVariable::checkInDictionary(StdString id)
+   {
+     // $ grep -rw getin ../src/|grep -v template|grep \"|awk -F \" '{ print $2}'|sort|uniq
+     set<StdString> dictionary_ = { 
+                                    "buffer_size_factor",
+                                    "call_oasis_enddef",
+                                    "check_event_sync",
+                                    "checksum_recv_fields",
+                                    "checksum_send_fields",
+                                    "clients_code_id",
+                                    "info_level",
+                                    "log_memory",
+                                    "log_type",
+                                    "max_buffer_size",
+                                    "memtrack_blocks",
+                                    "memtrack_size",
+                                    "min_buffer_size",
+                                    "number_pools_server2",
+                                    "optimal_buffer_size",
+                                    "print_file",
+                                    "pure_one_sided",
+                                    "ratio_server2",
+                                    "recv_field_timeout",
+                                    "server2_dist_file_memory",
+                                    "server2_dist_file_memory_ratio",
+                                    "server_puplish_timeout",
+                                    "system_stack",
+                                    "transport_protocol",
+                                    "using_oasis",
+                                    "using_server",
+                                    "using_server2",
+                                    "xios_stack"                        
+     };
+     if (dictionary_.find(id)==dictionary_.end())
+     {
+       ERROR("CVariable::checkInDictionary(StdString id)",
+              << "[ variable id = " << id
+              << " ] variable does not exist ! Check the syntax of your context id 'xios' in iodef.xml.");
+     }
    }
 
Index: XIOS3/branches/xios-3.0-beta/src/node/variable.hpp
===================================================================
--- XIOS3/branches/xios-3.0-beta/src/node/variable.hpp	(revision 2487)
+++ XIOS3/branches/xios-3.0-beta/src/node/variable.hpp	(revision 2495)
@@ -95,4 +95,5 @@
          private :
 
+            static void checkInDictionary(StdString id);
             StdString content;
 
Index: XIOS3/branches/xios-3.0-beta/xios_test_suite/TEST_SUITE/iodef.xml
===================================================================
--- XIOS3/branches/xios-3.0-beta/xios_test_suite/TEST_SUITE/iodef.xml	(revision 2487)
+++ XIOS3/branches/xios-3.0-beta/xios_test_suite/TEST_SUITE/iodef.xml	(revision 2495)
@@ -50,5 +50,5 @@
   <variable id="min_buffer_size" type="int">10000000</variable>
   <variable id="optimal_buffer_size" type="string">performance</variable>
-  <variable id="buffer_factor_size" type="double">0.8</variable> 
+  <!--variable id="buffer_factor_size" type="double">0.8</variable-->
       </variable_group>
 
@@ -63,5 +63,5 @@
         <variable id="check_event_sync" type="bool">true</variable>
       </variable_group>
-      <variable id="activate_non_distributed_transformation" type="bool">XIOS::NonDistTran</variable>
+      <!--variable id="activate_non_distributed_transformation" type="bool">XIOS::NonDistTran</variable-->
     </variable_definition>
   </context>