Index: /XIOS3/trunk/src/event_scheduler.cpp
===================================================================
--- /XIOS3/trunk/src/event_scheduler.cpp	(revision 2517)
+++ /XIOS3/trunk/src/event_scheduler.cpp	(revision 2518)
@@ -10,7 +10,7 @@
   CEventScheduler::CEventScheduler(const MPI_Comm& comm) 
   {
-    MPI_Comm_dup(comm, &communicator) ;
-    MPI_Comm_size(communicator,&mpiSize) ;
-    MPI_Comm_rank(communicator,&mpiRank);
+    MPI_Comm_dup(comm, &communicator_) ;
+    MPI_Comm_size(communicator_,&mpiSize_) ;
+    MPI_Comm_rank(communicator_,&mpiRank_);
 
 
@@ -23,20 +23,20 @@
       maxChild=maxChild+1 ;
       for(int i=0;i<maxChild;i++) m=m*maxChild ;
-     } while(m<mpiSize) ;
+     } while(m<mpiSize_) ;
     
     
     int maxLevel=0 ;
-    for(int size=1; size<=mpiSize; size*=maxChild) maxLevel++ ; 
+    for(int size=1; size<=mpiSize_; size*=maxChild) maxLevel++ ; 
 
     int begin, end, nb ;
     int pos, n ;
  
-    parent=vector<int>(maxLevel+1) ;
-    child=vector<vector<int> >(maxLevel+1,vector<int>(maxChild)) ;
-    nbChild=vector<int> (maxLevel+1) ;
+    parent_=vector<int>(maxLevel+1) ;
+    child_=vector<vector<int> >(maxLevel+1,vector<int>(maxChild)) ;
+    nbChild_=vector<int> (maxLevel+1) ;
    
-    level=0 ;
+    level_=0 ;
     begin=0 ;
-    end=mpiSize-1 ;     
+    end=mpiSize_-1 ;     
     nb=end-begin+1 ;
      
@@ -45,6 +45,6 @@
       n=0 ;
       pos=begin ;
-      nbChild[level]=0 ;
-      parent[level+1]=begin ;
+      nbChild_[level_]=0 ;
+      parent_[level_+1]=begin ;
       for(int i=0;i<maxChild && i<nb ;i++)
       {
@@ -52,15 +52,15 @@
         else n = nb/maxChild ;
       
-        if (mpiRank>=pos && mpiRank<pos+n)
+        if (mpiRank_>=pos && mpiRank_<pos+n)
         {
           begin=pos ;
           end=pos+n-1 ;
         }
-        child[level][i]=pos ;
+        child_[level_][i]=pos ;
         pos=pos+n ;
-        nbChild[level]++ ;
+        nbChild_[level_]++ ;
       } 
       nb=end-begin+1 ;
-      level=level+1 ;
+      level_=level_+1 ;
     } while (nb>1) ;
 
@@ -70,5 +70,5 @@
   CEventScheduler::~CEventScheduler()
   {
-    while (!pendingSentParentRequest.empty() || !pendingRecvParentRequest.empty() || !pendingRecvChildRequest.empty() ||  !pendingSentChildRequest.empty())
+    while (!pendingSentParentRequest_.empty() || !pendingRecvParentRequest_.empty() || !pendingRecvChildRequest_.empty() ||  !pendingSentChildRequest_.empty())
     {
       checkEvent() ;
@@ -78,5 +78,5 @@
   void CEventScheduler::registerEvent(const size_t timeLine, const size_t contextHashId)
   {
-    registerEvent(timeLine, contextHashId, level) ;
+    registerEvent(timeLine, contextHashId, level_) ;
     checkEvent() ;
   }
@@ -91,6 +91,6 @@
     sentRequest->buffer[2]=lev-1 ;
 
-    pendingSentParentRequest.push(sentRequest) ;
-    MPI_Isend(sentRequest->buffer,3, MPI_UNSIGNED_LONG, parent[lev], 0, communicator, &sentRequest->request) ;
+    pendingSentParentRequest_.push(sentRequest) ;
+    MPI_Isend(sentRequest->buffer,3, MPI_UNSIGNED_LONG, parent_[lev], 0, communicator_, &sentRequest->request) ;
     traceOn() ;
   } 
@@ -99,7 +99,7 @@
   {
     checkEvent() ;
-    if (! eventStack.empty() && eventStack.front().first==timeLine && eventStack.front().second==contextHashId)
-    {
-      //eventStack.pop() ;
+    if (! eventStack_.empty() && eventStack_.front().first==timeLine && eventStack_.front().second==contextHashId)
+    {
+      //eventStack_.pop() ;
       return true ;
     }
@@ -125,11 +125,11 @@
     
     // check sent request to parent
-    while (! pendingSentParentRequest.empty() && completed)
-    {
-      MPI_Test( & pendingSentParentRequest.front()->request, &completed, &status) ;
+    while (! pendingSentParentRequest_.empty() && completed)
+    {
+      MPI_Test( & pendingSentParentRequest_.front()->request, &completed, &status) ;
       if (completed) 
       {
-        delete pendingSentParentRequest.front() ;
-        pendingSentParentRequest.pop() ;
+        delete pendingSentParentRequest_.front() ;
+        pendingSentParentRequest_.pop() ;
       }
     }
@@ -139,10 +139,10 @@
     while(received)
     {
-      MPI_Iprobe(MPI_ANY_SOURCE,1,communicator,&received, &status) ;
+      MPI_Iprobe(MPI_ANY_SOURCE,1,communicator_,&received, &status) ;
       if (received)
       {
         recvRequest=new SPendingRequest ;
-        MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, MPI_ANY_SOURCE, 1, communicator, &(recvRequest->request)) ;
-        pendingRecvParentRequest.push(recvRequest) ;
+        MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, MPI_ANY_SOURCE, 1, communicator_, &(recvRequest->request)) ;
+        pendingRecvParentRequest_.push(recvRequest) ;
       }
     }
@@ -150,7 +150,7 @@
      // check sent request from parent
     completed=true ;
-    while (! pendingRecvParentRequest.empty() && completed)
-    {
-      recvRequest=pendingRecvParentRequest.front() ;
+    while (! pendingRecvParentRequest_.empty() && completed)
+    {
+      recvRequest=pendingRecvParentRequest_.front() ;
       MPI_Test( &(recvRequest->request), &completed, &status) ;
       if (completed) 
@@ -160,7 +160,7 @@
         size_t lev=recvRequest->buffer[2] ;
         delete recvRequest ;
-        pendingRecvParentRequest.pop() ;       
- 
-        if (lev==level) eventStack.push(pair<size_t,size_t>(timeLine,hashId)) ;
+        pendingRecvParentRequest_.pop() ;       
+ 
+        if (lev==level_) eventStack_.push(pair<size_t,size_t>(timeLine,hashId)) ;
         else  bcastEvent(timeLine, hashId, lev) ;
       }
@@ -181,10 +181,10 @@
     while(received)
     {
-      MPI_Iprobe(MPI_ANY_SOURCE,0,communicator,&received, &status) ;
+      MPI_Iprobe(MPI_ANY_SOURCE,0,communicator_,&received, &status) ;
       if (received)
       {
         recvRequest=new SPendingRequest ;
-        MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, MPI_ANY_SOURCE, 0, communicator, &recvRequest->request) ;
-        pendingRecvChildRequest.push_back(recvRequest) ;
+        MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, MPI_ANY_SOURCE, 0, communicator_, &recvRequest->request) ;
+        pendingRecvChildRequest_.push_back(recvRequest) ;
       }
     }
@@ -192,5 +192,5 @@
     // check if receive request is achieved
     
-    for(list<SPendingRequest*>::iterator it=pendingRecvChildRequest.begin(); it!=pendingRecvChildRequest.end() ; )
+    for(list<SPendingRequest*>::iterator it=pendingRecvChildRequest_.begin(); it!=pendingRecvChildRequest_.end() ; )
     {
       MPI_Test(&((*it)->request),&received,&status) ;
@@ -203,24 +203,24 @@
         SEvent event={timeLine,hashId,lev} ;
         delete *it ; // free mem
-        it=pendingRecvChildRequest.erase(it) ; // get out of the list
+        it=pendingRecvChildRequest_.erase(it) ; // get out of the list
         
-        map< SEvent,int>::iterator itEvent=recvEvent.find(event) ;
-        if (itEvent==recvEvent.end()) 
+        map< SEvent,int>::iterator itEvent=recvEvent_.find(event) ;
+        if (itEvent==recvEvent_.end()) 
         {
-          itEvent=(recvEvent.insert(pair< SEvent ,int > (event,1))).first ;
+          itEvent=(recvEvent_.insert(pair< SEvent ,int > (event,1))).first ;
  
         }
         else (itEvent->second)++ ;
-        if (itEvent->second==nbChild[lev])
+        if (itEvent->second==nbChild_[lev])
         {
           if (lev==0)
           {
             bcastEvent(timeLine,hashId,lev) ;
-            recvEvent.erase(itEvent) ;
+            recvEvent_.erase(itEvent) ;
           }
           else
           {
             registerEvent( timeLine,hashId,lev) ;
-            recvEvent.erase(itEvent) ;
+            recvEvent_.erase(itEvent) ;
           }
         }
@@ -231,5 +231,5 @@
     // check if bcast request is achieved
 
-    for(list<SPendingRequest*>::iterator it=pendingSentChildRequest.begin(); it!=pendingSentChildRequest.end() ; )
+    for(list<SPendingRequest*>::iterator it=pendingSentChildRequest_.begin(); it!=pendingSentChildRequest_.end() ; )
     {
       MPI_Test(&(*it)->request,&received,&status) ;
@@ -237,5 +237,5 @@
       {
         delete *it ;    // free memory
-        it = pendingSentChildRequest.erase(it) ;          // get out of the list
+        it = pendingSentChildRequest_.erase(it) ;          // get out of the list
 
       }
@@ -250,5 +250,5 @@
      
     
-    for(int i=0; i<nbChild[lev];i++)
+    for(int i=0; i<nbChild_[lev];i++)
     {
       sentRequest=new SPendingRequest ;
@@ -256,6 +256,6 @@
       sentRequest->buffer[1]=contextHashId ;
       sentRequest->buffer[2]=lev+1 ;
-      MPI_Isend(sentRequest->buffer,3, MPI_UNSIGNED_LONG, child[lev][i], 1, communicator, & sentRequest->request) ;
-      pendingSentChildRequest.push_back(sentRequest) ;
+      MPI_Isend(sentRequest->buffer,3, MPI_UNSIGNED_LONG, child_[lev][i], 1, communicator_, & sentRequest->request) ;
+      pendingSentChildRequest_.push_back(sentRequest) ;
     }
   }
Index: /XIOS3/trunk/src/event_scheduler.hpp
===================================================================
--- /XIOS3/trunk/src/event_scheduler.hpp	(revision 2517)
+++ /XIOS3/trunk/src/event_scheduler.hpp	(revision 2518)
@@ -52,5 +52,5 @@
         */    
        bool queryEvent(const size_t timeLine, const size_t contextHashId) ;
-       void popEvent() { eventStack.pop() ; }
+       void popEvent() { eventStack_.pop() ; }
 
 
@@ -155,20 +155,20 @@
        } ;
        
-       MPI_Comm communicator ;  /*!< Internal MPI communicator */ 
-       int mpiRank ;            /*!< Rank in the communicator */
-       int mpiSize ;            /*!< Size of the communicator */
+       MPI_Comm communicator_ ;  /*!< Internal MPI communicator */ 
+       int mpiRank_ ;            /*!< Rank in the communicator */
+       int mpiSize_ ;            /*!< Size of the communicator */
  
-       queue< pair<size_t, size_t> > eventStack ;          
-       queue<SPendingRequest* > pendingSentParentRequest ;   /*!< Pending request sent to parent   */
-       queue<SPendingRequest*>  pendingRecvParentRequest ;   /*!< Pending request recv from parent */    
-       list<SPendingRequest* >  pendingRecvChildRequest ;    /*!< Pending request recv from child  */
-       list<SPendingRequest*>   pendingSentChildRequest ;    /*!< Pending request sent to child    */
-       map< SEvent, int > recvEvent ;                        /*!< list of event received from children. Contains the currnet number children that have already post the same event */
+       queue< pair<size_t, size_t> > eventStack_ ;          
+       queue<SPendingRequest* > pendingSentParentRequest_ ;   /*!< Pending request sent to parent   */
+       queue<SPendingRequest*>  pendingRecvParentRequest_ ;   /*!< Pending request recv from parent */    
+       list<SPendingRequest* >  pendingRecvChildRequest_ ;    /*!< Pending request recv from child  */
+       list<SPendingRequest*>   pendingSentChildRequest_ ;    /*!< Pending request sent to child    */
+       map< SEvent, int > recvEvent_ ;                        /*!< list of event received from children. Contains the currnet number children that have already post the same event */
        
        
-       int level ;                   /*!< Number of hierachical level for communication */
-       vector<int> parent ;          /*!< Parent rank for each level */ 
-       vector<vector<int> >  child ; /*!< List of child rank for each level */
-       vector<int> nbChild ;         /*!< Number of child for each level */    
+       int level_ ;                   /*!< Number of hierachical level for communication */
+       vector<int> parent_ ;          /*!< Parent rank for each level */ 
+       vector<vector<int> >  child_ ; /*!< List of child rank for each level */
+       vector<int> nbChild_ ;         /*!< Number of child for each level */    
 
     } ;